# -*- coding: utf-8 -*-
import sys, re
from bs4 import BeautifulSoup
try:
    from urllib2 import urlopen, Request
except ImportError:
    from urllib.request import urlopen, Request
try:
    from urlparse import urljoin, unquote
except ImportError:
    from urllib.parse import urljoin, unquote
ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4280.88 Safari/537.36'


def getsoup(url):
    request = Request(url, headers={'User-Agent': ua})
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(urlopen(request), 'html.parser')
    return BeautifulSoup(urlopen(request), 'html5lib')


def gethttp(url):
    request = Request(url, headers={'User-Agent': ua})
    return urlopen(request).read().decode('utf-8')


def play(url):
    try:
        content = gethttp(url)
    except Exception as e:
        return {'code': '91porn 100', 'error': str(e)}
    url = re.search(r'strencode2\("(.+?)"\)', content)
    if not url:
        return {'code': '91porn 101'}
    url = url.group(1)
    url = unquote(url)
    url = re.search(r'src=\'(.+?)\'', url)
    if not url:
        return {'code': '91porn 102'}
    url = url.group(1)
    return {'': url}


def category(page=1):
    url = 'https://www.91porn.com/v.php?category=rf&viewtype=basic&page=%d' % page
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': '91porn 200', 'error': str(e)}
    ret = []
    for e in soup.select('div.col-sm-12 div.col-xs-12 div.well a'):
        title = e.select('span.video-title')[0].text.strip()
        img = e.select('img.img-responsive')[0]['src']
        plot = []
        for e1 in e.parent.select('span.duration'):
            plot.append(e1.text)
        for e1 in e.parent.select('span.info'):
            plot.append('%s %s' % (e1.text, e1.next_sibling.strip()))
        plot = '\n'.join(plot)
        ret.append({'title': title, 'url': urljoin(url, e['href']), 'img': img, 'plot': plot})
    ret.append({'title': 'Load more (%d)' % (page + 1), 'page': page + 1})
    return ret
